import { BaseVisitor, ParsedConfig, RawConfig } from './index';
import { FragmentDefinitionNode, OperationDefinitionNode } from 'graphql';
export interface RawClientSideBasePluginConfig extends RawConfig {
    noGraphQLTag?: boolean;
    gqlImport?: string;
}
export interface ClientSideBasePluginConfig extends ParsedConfig {
    noGraphQLTag: boolean;
    gqlImport: string;
}
export declare class ClientSideBaseVisitor<TRawConfig extends RawClientSideBasePluginConfig = RawClientSideBasePluginConfig, TPluginConfig extends ClientSideBasePluginConfig = ClientSideBasePluginConfig> extends BaseVisitor<TRawConfig, TPluginConfig> {
    protected _fragments: FragmentDefinitionNode[];
    constructor(_fragments: FragmentDefinitionNode[], rawConfig: TRawConfig, additionalConfig: Partial<TPluginConfig>);
    protected _getFragmentName(fragment: FragmentDefinitionNode | string): string;
    protected _extractFragments(document: FragmentDefinitionNode | OperationDefinitionNode): string[] | undefined;
    protected _transformFragments(document: FragmentDefinitionNode | OperationDefinitionNode): string[] | undefined;
    protected _includeFragments(fragments: string[]): string;
    protected _prepareDocument(documentStr: string): string;
    protected _gql(node: FragmentDefinitionNode | OperationDefinitionNode): string;
    protected _generateFragment(fragmentDocument: FragmentDefinitionNode): string | void;
    readonly fragments: string;
    protected _parseImport(importStr: string): {
        moduleName: string;
        propName: string;
    };
    getImports(): string;
    protected buildOperation(node: OperationDefinitionNode, documentVariableName: string, operationType: string, operationResultType: string, operationVariablesTypes: string): string;
    OperationDefinition(node: OperationDefinitionNode): string;
}
